/**
 * $Id: JDBCPrincipal.java,v 1.2 2004/02/05 17:54:23 vs125812 Exp $
 * Copyright  2004 Sun Microsystems, Inc. All rights reserved. 
 * 
 * Sun Microsystems, Inc. has intellectual property rights relating to
 * technology embodied in the product that is described in this document.
 * In particular, and without limitation, these intellectual property rights
 * may include one or more of the U.S. patents listed at
 * http://www.sun.com/patents and one or more additional patents or pending
 * patent applications in the U.S. and in other countries.
 * 
 * U.S. Government Rights - Commercial software. Government users are subject
 * to the Sun Microsystems, Inc. standard license agreement and applicable
 * provisions of the FAR and its supplements.
 * 
 * Use is subject to license terms. 
 * 
 * This distribution may include materials developed by third parties. Sun,
 * Sun Microsystems, the Sun logo, Java and Sun[tm] ONE are trademarks or
 * registered trademarks of Sun Microsystems, Inc. in the U.S. and other
 * countries. 
 * 
 * Copyright  2004 Sun Microsystems, Inc. Tous droits rservs. Sun
 * Microsystems, Inc. dtient les droits de proprit intellectuels relatifs
 *  la technologie incorpore dans le produit qui est dcrit dans ce document.
 * En particulier, et ce sans limitation, ces droits de proprit
 * intellectuelle peuvent inclure un ou plus des brevets amricains lists
 *  l'adresse http://www.sun.com/patents et un ou les brevets supplmentaires
 * ou les applications de brevet en attente aux Etats - Unis et dans les
 * autres pays.
 * 
 * L'utilisation est soumise aux termes du contrat de licence.
 * 
 * Cette distribution peut comprendre des composants dvelopps par des
 * tierces parties.
 * 
 * Sun, Sun Microsystems, le logo Sun, Java et Sun[tm] ONE sont des marques
 * de fabrique ou des marques dposes de Sun Microsystems, Inc. aux
 * Etats-Unis et dans d'autres pays.
 */

package  com.iplanet.am.samples.authentication.spi.jdbc;
import java.io.IOException;
import javax.security.auth.*;
import javax.security.auth.login.*;
import javax.security.auth.callback.*;
import java.security.Principal;

public class JDBCPrincipal implements Principal, java.io.Serializable {

  /**
   * @serial
   */
    private String name;

    public JDBCPrincipal(String name) {
        if (name == null)
            throw new NullPointerException("illegal null input");
        this.name = name;
    }

  /**
   * Return the JDBC username for this <code>JDBCPrincipal</code>.
   *
   * <p>
   *
   * @return the JDBC username for this <code>JDBCPrincipal</code>
   */
    public String getName() {
        return name;
    }

  /**
   * Return a string representation of this <code>JDBCPrincipal</code>.
   *
   * <p>
   *
   * @return a string representation of this <code>JDBCPrincipal</code>.
   */
    public String toString() {
        return ("JDBCPrincipal:  " + name);
    }

  /**
   * Compares the specified Object with this <code>JDBCPrincipal</code>
   * for equality.  Returns true if the given object is also a
   * <code>JDBCPrincipal</code> and the two JDBCPrincipals
   * have the same username.
   *
   * <p>
   *
   * @param o Object to be compared for equality with this
   *            <code>JDBCPrincipal</code>.
   *
   * @return true if the specified Object is equal equal to this
   *            <code>JDBCPrincipal</code>.
   */
    public boolean equals(Object o) {
        if (o == null)
            return false;

        if (this == o)
            return true;

        if (!(o instanceof JDBCPrincipal))
            return false;
        JDBCPrincipal that = (JDBCPrincipal) o;

        if (this.getName().equals(that.getName()))
            return true;
        return false;
    }

  /**
   * Return a hash code for this <code>JDBCPrincipal</code>.
   *
   * <p>
   *
   * @return a hash code for this <code>JDBCPrincipal</code>.
   */
    public int hashCode() {
        return name.hashCode();
    }
}
